import Feature from "./Feature";
import { ListFeatureOptions } from "../types/Feature";
import { CreatePricingTierParams, ListPricingTierOptions } from "../types/PricingTier";
import Warrant, { Context, WarrantObject } from "../types/Warrant";
export default class PricingTier implements WarrantObject {
    pricingTierId: string;
    constructor(pricingTierId: string);
    static create(pricingTier: CreatePricingTierParams): Promise<PricingTier>;
    static get(pricingTierId: string): Promise<PricingTier>;
    static delete(pricingTierId: string): Promise<void>;
    static listPricingTiers(listOptions?: ListPricingTierOptions): Promise<PricingTier[]>;
    static listPricingTiersForTenant(tenantId: string, listOptions?: ListPricingTierOptions): Promise<PricingTier[]>;
    static assignPricingTierToTenant(tenantId: string, pricingTierId: string): Promise<Warrant>;
    static removePricingTierFromTenant(tenantId: string, pricingTierId: string): Promise<void>;
    static listPricingTiersForUser(userId: string, listOptions?: ListPricingTierOptions): Promise<PricingTier[]>;
    static assignPricingTierToUser(userId: string, pricingTierId: string): Promise<Warrant>;
    static removePricingTierFromUser(userId: string, pricingTierId: string): Promise<void>;
    listFeatures(listOptions?: ListFeatureOptions): Promise<Feature[]>;
    assignFeature(featureId: string): Promise<Warrant>;
    removeFeature(featureId: string): Promise<void>;
    hasFeature(featureId: string, context?: Context): Promise<boolean>;
    getObjectType(): string;
    getObjectId(): string;
}
