import Permission from "./Permission";
import { ListPermissionOptions } from "../types/Permission";
import { CreateRoleParams, ListRoleOptions, UpdateRoleParams } from "../types/Role";
import Warrant, { Context, WarrantObject } from "../types/Warrant";
export default class Role implements WarrantObject {
    roleId: string;
    name?: string;
    description?: string;
    constructor(roleId: string, name?: string, description?: string);
    static create(role: CreateRoleParams): Promise<Role>;
    static get(roleId: string): Promise<Role>;
    static update(roleId: string, role: UpdateRoleParams): Promise<Role>;
    static delete(roleId: string): Promise<void>;
    static listRoles(listOptions?: ListRoleOptions): Promise<Role[]>;
    static listRolesForUser(userId: string, listOptions?: ListRoleOptions): Promise<Role[]>;
    static assignRoleToUser(userId: string, roleId: string): Promise<Warrant>;
    static removeRoleFromUser(userId: string, roleId: string): Promise<void>;
    listPermissions(listOptions?: ListPermissionOptions): Promise<Permission[]>;
    assignPermission(permissionId: string): Promise<Warrant>;
    removePermission(permissionId: string): Promise<void>;
    hasPermission(permissionId: string, context?: Context): Promise<boolean>;
    getObjectType(): string;
    getObjectId(): string;
}
